﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace TestCustomZoomLevels
{
    public partial class frmMainDisplay : Form
    {
        public frmMainDisplay()
        {
            InitializeComponent();
        }

        private void frmMainDisplay_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            winformsMap1.CurrentExtent = ExtentHelper.GetDrawingExtent(new RectangleShape(-97.7612400054933, 30.2895641326905, -97.729482650757, 30.2669048309327), winformsMap1.Width, winformsMap1.Height);
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.FromArgb(255, 233, 232, 214));

            ShapeFileFeatureLayer featureLayer = new ShapeFileFeatureLayer("C:\\Program Files\\ThinkGeo\\Map Suite Desktop Full Edition 3.0\\Samples\\SampleData\\Data\\Austinstreets.shp", ShapeFileReadWriteMode.ReadOnly);

            featureLayer.Open();
            RectangleShape bounds = featureLayer.GetBoundingBox();
            featureLayer.Close();
            
            
            ZoomLevelSet zooms = GetCustomZoomLevels();

            winformsMap1.ZoomLevelSet = zooms;
            winformsMap1.ZoomLevelSnapping = ZoomLevelSnappingMode.SnapUp;
            featureLayer.ZoomLevelSet = zooms;
            
            featureLayer.ZoomLevelSet.CustomZoomLevels[0].CustomStyles.Add(LineStyles.LocalRoad2);
            featureLayer.ZoomLevelSet.CustomZoomLevels[0].ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay staticOverlay = new LayerOverlay();
            staticOverlay.Layers.Add("AustinStreets", featureLayer);
            winformsMap1.Overlays.Add("StreetsOverlay", staticOverlay);

            winformsMap1.Refresh();   

        }

        private ZoomLevelSet GetCustomZoomLevels()
        {
            ZoomLevelSet ReturnValue = new ZoomLevelSet();

            ZoomLevel zoom = new ZoomLevel(500000.0);
            zoom.Name = "1";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(319365.0);
            zoom.Name = "2";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(203988.0);
            zoom.Name = "3";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(130293.0);
            zoom.Name = "4";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(83222.0);
            zoom.Name = "5";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(53157.0);
            zoom.Name = "6";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(33953.0);
            zoom.Name = "7";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(21687.0);
            zoom.Name = "8";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(13852.0);
            zoom.Name = "9";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(8848.0);
            zoom.Name = "10";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(5651.0);
            zoom.Name = "11";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(3610.0);
            zoom.Name = "12";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(2306.0);
            zoom.Name = "13";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(1473.0);
            zoom.Name = "14";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(941.0);
            zoom.Name = "15";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(601.0);
            zoom.Name = "16";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(384.0);
            zoom.Name = "17";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(245.0);
            zoom.Name = "18";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(157.0);
            zoom.Name = "19";
            ReturnValue.CustomZoomLevels.Add(zoom);

            zoom = new ZoomLevel(100.0);
            zoom.Name = "20";
            ReturnValue.CustomZoomLevels.Add(zoom);

            return ReturnValue;
        }

        private void winformsMap1_CurrentExtentChanged(object sender, CurrentExtentChangedWinformsMapEventArgs e)
        {
            textBox1.Text = GetCurrentZoomLevel(winformsMap1.CurrentScale).ToString();
        }


        private int GetCurrentZoomLevel(double scale)
        {
            int ReturnValue = -1;
            if (winformsMap1.ZoomLevelSet.CustomZoomLevels.Count > 0)
            {
                for (int looper = 0; looper < 20; looper++)
                {
                    if (Math.Abs(winformsMap1.ZoomLevelSet.CustomZoomLevels[looper].Scale - scale) < .01)
                        ReturnValue = looper + 1;
                }
            }
            return ReturnValue;
        }

    }
}
